#include <ofono/log.h>
#include <glib.h>
#include <gutil_idlepool.h>
#include <glib-object.h>

#include <binder_ext_call_impl.h>

#include "vendor_qti_types.h"

#include "vendor_qti_ims_call.h"
#include "vendor_qti_ims_radio.h"
#include "vendor_qti_ims_state.h"

typedef GObjectClass VendorQtiImsCallClass;//sizeof(GObjectClass) == 136LL arm64
struct qti_ims_call {
    GObject parent;// sizeof(GObject) == 24LL arm64
    GUtilIdlePool* idle;
    VendorQtiImsRadio* ims_radio;
    VendorQtiImsStateObject* ims_state;
    void * v_4;
    void * v_5;
    void * v_6;
    void * v_7;
    void * v_8;
    void * v_9;
    void * v_10;
    void * v_11;
    void * v_12;
    void * v_13;
    GHashTable* string_table;
    GHashTable* table;
    void * v_16;
}; // sizeof(VendorQtiImsCall) == 152LL arm64

static void qti_ims_call_iface_init(BinderExtCallInterface* iface);

G_DEFINE_TYPE_WITH_CODE(VendorQtiImsCall, qti_ims_call, G_TYPE_OBJECT,
G_IMPLEMENT_INTERFACE(BINDER_EXT_TYPE_CALL, qti_ims_call_iface_init))

#define THIS_TYPE qti_ims_call_get_type()
#define THIS(obj) G_TYPE_CHECK_INSTANCE_CAST(obj, THIS_TYPE, VendorQtiImsCall)
#define IS_THIS(obj) G_TYPE_CHECK_INSTANCE_TYPE(obj, THIS_TYPE)

static
void
qti_ims_call_init(
    VendorQtiImsCall* self)
{;
    self->idle = gutil_idle_pool_new();
    self->table = g_hash_table_new(&g_direct_hash, &g_direct_equal);
    self->string_table = g_hash_table_new_full(&g_str_hash, &g_str_equal, &g_free, &g_free);
}

static
void
qti_ims_call_class_init(
    VendorQtiImsCallClass* klass)
{

}
static void qti_ims_call_iface_init(BinderExtCallInterface* iface){

}

BinderExtCall* vendor_qti_ims_call_new(VendorQtiImsRadio* ims_radio, VendorQtiImsStateObject* ims_state){
    
    VendorQtiImsCall* self = g_object_new(THIS_TYPE, NULL);
    self->ims_radio = vendor_qti_ims_radio_ref(ims_radio);
    self->ims_state = vendor_qti_ims_state_ref(ims_state);


    return BINDER_EXT_CALL(self);
}
/*
vendor_qti_ims_call_conference_info_start_element
vendor_qti_ims_call_reg_state_update
vendor_qti_ims_call_hangup
vendor_qti_ims_call_send_dtmf
vendor_qti_ims_call_conference
vendor_qti_ims_call_conference_request_complete
vendor_qti_ims_call_swap
vendor_qti_ims_call_result_request_continue
vendor_qti_ims_call_result_request_continue_resume
vendor_qti_ims_call_result_request_continue_answer
vendor_qti_ims_call_answer
vendor_qti_ims_call_dial
vendor_qti_ims_call_handle_conference_info
vendor_qti_ims_call_handle_conf_user_deleted
vendor_qti_ims_call_handle_conf_user_info_changed
vendor_qti_ims_call_handle_state_change
*/