#include <ofono/log.h>
#include "binder_ext_sms_impl.h"

#include "vendor_qti_types.h"
#include "vendor_qti_ims_sms.h"

typedef GObjectClass VendorQtiImsSmsClass;
struct qti_ims_sms {
    GObject parent;// sizeof(GObject) == 24LL
    VendorQtiImsRadio* ims_radio;
    VendorQtiImsStateObject* ims_state;
    gulong incoming;
    gulong status_report;
};// sizeof(VendorQtiImsSms) == 56LL

static void qti_ims_sms_iface_init(BinderExtSmsInterface* iface);
G_DEFINE_TYPE_WITH_CODE(VendorQtiImsSms, qti_ims_sms, G_TYPE_OBJECT,
G_IMPLEMENT_INTERFACE(BINDER_EXT_TYPE_SMS, qti_ims_sms_iface_init))

#define QTI_TYPE_SMS qti_ims_sms_get_type()
#define QTI_IMS_SMS(obj) G_TYPE_CHECK_INSTANCE_CAST(obj, QTI_TYPE_SMS, VendorQtiImsSms)

enum qti_ims_sms_signal {
    SIGNAL_INCOMING,
    SIGNAL_STATUS_REPORT,
    SIGNAL_COUNT
};

#define SIGNAL_INCOMING_NAME "qti-ims-sms-incoming"
#define SIGNAL_STATUS_REPORT_NAME "qti-ims-sms-status-report"

static guint qti_ims_sms_signals[SIGNAL_COUNT] = { 0 };


static
void
qti_ims_sms_init(
    VendorQtiImsSms* self)
{
}

static
void
qti_ims_sms_class_init(
    VendorQtiImsSmsClass* klass)
{
    qti_ims_sms_signals[SIGNAL_INCOMING] = g_signal_new(SIGNAL_INCOMING_NAME, 
                                    G_TYPE_FROM_CLASS (klass), 
                                    1LL, 0LL, 0LL, 0LL, 0LL, 4LL, 2, 68LL);
    qti_ims_sms_signals[SIGNAL_STATUS_REPORT] = g_signal_new(SIGNAL_STATUS_REPORT_NAME, 
                                    G_TYPE_FROM_CLASS (klass), 
                                    1LL, 0LL, 0LL, 0LL, 0LL, 4LL, 3, 68LL);
}


/*****************************
 * Interface
 * ***************************/
guint vendor_qti_ims_sms_send(BinderExtSms* ext, const char* smsc, const void* pdu,
    gsize pdu_len, guint msg_ref, BINDER_EXT_SMS_SEND_FLAGS flags,
    BinderExtSmsSendFunc complete, GDestroyNotify destroy,
    void* user_data){
    return 0;
}
void vendor_qti_ims_sms_cancel(BinderExtSms* ext, guint id){

}
void vendor_qti_ims_sms_ack_report(BinderExtSms* ext, guint msg_ref, gboolean ok){
    
}
void vendor_qti_ims_sms_ack_incoming(BinderExtSms* ext, gboolean ok){
    
}
gulong vendor_qti_ims_sms_add_report_handler(BinderExtSms* ext,
    BinderExtSmsReportFunc handler, void* user_data){
    return 0;
}
gulong vendor_qti_ims_sms_add_incoming_handler(BinderExtSms* ext,
    BinderExtSmsIncomingFunc handler, void* user_data){
    return 0;
}
void vendor_qti_ims_sms_remove_handler(BinderExtSms* ext, gulong id){
    
}


static void qti_ims_sms_iface_init(BinderExtSmsInterface* iface){
    iface->flags |= BINDER_EXT_SMS_INTERFACE_FLAG_IMS_SUPPORT | BINDER_EXT_SMS_INTERFACE_FLAG_IMS_REQUIRED;
    iface->version = 1;
    iface->send = vendor_qti_ims_sms_send;
    iface->cancel = vendor_qti_ims_sms_cancel;
    iface->ack_report = vendor_qti_ims_sms_ack_report;
    iface->ack_incoming = vendor_qti_ims_sms_ack_incoming;
    iface->add_report_handler = vendor_qti_ims_sms_add_report_handler;
    iface->add_incoming_handler = vendor_qti_ims_sms_add_incoming_handler;
    iface->remove_handler = vendor_qti_ims_sms_remove_handler;
}

static qti_ims_sms_signal_emit_incoming(){

}
gulong qti_ims_sms_connect_signal_incoming(VendorQtiImsRadio* ims_radio){

}

BinderExtSms* vendor_qti_ims_sms_new(VendorQtiImsRadio* ims_radio,VendorQtiImsStateObject* ims_state){
    VendorQtiImsSms* self = g_object_new(QTI_TYPE_SMS, NULL);
    
    self->ims_state = vendor_qti_ims_state_ref(ims_state);
    self->ims_radio = vendor_qti_ims_radio_ref(ims_radio);
    
    //self->incoming = g_signal_connect(ims_radio,"");
    //self->status_report = ;
    //qti-ims-radio-incoming-sms
    //qti-ims-radio-sms-status-report

    return BINDER_EXT_IMS(self);
}