#include <ofono/log.h>
#include <glib-object.h>
#include "vendor_qti_ims_state.h"

// G_OBJECT_CLASS(klass)->finalize     *GObjectClass + 48 = finalize arm64
typedef GObjectClass VendorQtiImsStateObjectClass;// sizeof(GObjectClass) == 136LL
struct qti_ims_state{
    GObject parent;// sizeof(GObject) == 24LL
    gulong l_1;
    VendorQtiImsRadio* ims_radio;
    gulong connect_signal_handler_id;
    void * v_4;
}; // sizeof(VendorQtiImsStateObject) == 56LL arm64

G_DEFINE_TYPE(VendorQtiImsStateObject, qti_ims_state, G_TYPE_OBJECT)

#define THIS_TYPE qti_ims_state_get_type()
#define THIS(obj) G_TYPE_CHECK_INSTANCE_CAST(obj, THIS_TYPE, VendorQtiImsStateObject)
#define IS_THIS(obj) G_TYPE_CHECK_INSTANCE_TYPE(obj, THIS_TYPE)
#define PARENT_CLASS qti_ims_state_parent_class


#define SIGNAL_PROPERTY_CHANGED_NAME "qti-ims-state-property-changed"
static guint property_changed_signal = 0;

static
void
qti_ims_state_finalize(
    GObject* object)
{
    VendorQtiImsStateObject* self = THIS(object);
    // ...
    G_OBJECT_CLASS(PARENT_CLASS)->finalize(object);
}


static
void
qti_ims_state_init(
    VendorQtiImsStateObject* self)
{
    self->l_1 = 0x1500000003LL;
}
static
void
qti_ims_state_class_init(
    VendorQtiImsStateObjectClass* klass)
{
    G_OBJECT_CLASS(klass)->finalize = qti_ims_state_finalize;
    property_changed_signal = g_signal_new(SIGNAL_PROPERTY_CHANGED_NAME,
        G_TYPE_FROM_CLASS(klass), G_SIGNAL_RUN_FIRST, 0, NULL, NULL, NULL, G_TYPE_NONE, 1, 28LL);
}

VendorQtiImsStateObject* vendor_qti_ims_state_new(VendorQtiImsRadio* ims_radio){

     VendorQtiImsStateObject* self = g_object_new(THIS_TYPE, NULL);
    
    self->ims_radio = vendor_qti_ims_radio_ref(ims_radio);

    return self;
}

VendorQtiImsStateObject*
vendor_qti_ims_state_ref(
    VendorQtiImsStateObject* self)
{
    if (G_LIKELY(self)) {
        g_object_ref(self);
    }
    return self;
}

void
vendor_qti_ims_state_unref(
    VendorQtiImsStateObject* self)
{
    if (G_LIKELY(self)) {
        g_object_unref(self);
    }
}